<script lang="ts">
  import { createEventDispatcher } from 'svelte'

  const dispatch = createEventDispatcher()

  export let checked: boolean | undefined;
  export let id: string | undefined = undefined;
  export let name = '';
  export let disabled = false;
  export let label;

  let clazz = ''
  export { clazz as class };

  // todo can this use indeterminate? https://getbootstrap.com/docs/5.3/forms/checks-radios/#indeterminate

  function handleChange() {
    // handle initial state of undefined
    if (checked === undefined) {
      checked = false;
    } else {
      checked = !checked;
    }
    dispatch('change', checked);
  }

  $: switchClass = checked === undefined ? 'bg-secondary center' :
    (checked ? 'bg-success right' : 'bg-danger left');
</script>

<button on:click={handleChange} class="form-check form-switch d-flex justify-content-center ps-0 clickable w-100">
  {#if label}
    <label for={id} class="me-auto">
      {label}
    </label>
  {/if}
  <input
    type="checkbox"
    class="form-check-input {switchClass} float-end"
    role="switch"
    {id}
    {name}
    {disabled}
    checked={checked}
    style="cursor: pointer;"
  />
</button>

<style>
    .form-check-input {
        width: 3em !important;
        height: 1.5em !important;
        border: none !important;
        cursor: pointer !important;
        transition: all 0.15s ease-in-out !important;
    }

    /* Position states */
    .form-check-input.left {
        background-position: left center !important;
    }

    .form-check-input.center {
        background-position: center center !important;
    }

    .form-check-input.right {
        background-position: right center !important;
    }

    /* Override Bootstrap's default focus styles */
    .form-check-input:focus {
        box-shadow: none !important;
        border-color: transparent !important;
    }
</style>